"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from datetime import datetime
import pydantic
from pydantic import model_serializer
from ttd_workflows.types import (
    BaseModel,
    Nullable,
    OptionalNullable,
    UNSET,
    UNSET_SENTINEL,
)
from typing_extensions import Annotated, NotRequired, TypedDict


class BulkJobStatusResponseTypedDict(TypedDict):
    id: int
    r"""ID of the bulk job."""
    created_at_utc: datetime
    r"""Time of creation for that bulk job in UTC."""
    status: str
    r"""Status of that bulk job."""
    completed_at_utc: NotRequired[Nullable[datetime]]
    r"""Time of completion for this bulk job in UTC."""
    completion_percentage: NotRequired[Nullable[float]]
    r"""Completion percentage for that bulk job."""
    url: NotRequired[Nullable[str]]
    r"""The url where the result can be picked up"""
    raw_result: NotRequired[Nullable[str]]
    r"""The raw result if the response is less than 5MB in size"""
    gql_errors: NotRequired[Nullable[str]]
    r"""Any GraphQl errors"""


class BulkJobStatusResponse(BaseModel):
    id: int
    r"""ID of the bulk job."""

    created_at_utc: Annotated[datetime, pydantic.Field(alias="createdAtUtc")]
    r"""Time of creation for that bulk job in UTC."""

    status: str
    r"""Status of that bulk job."""

    completed_at_utc: Annotated[
        OptionalNullable[datetime], pydantic.Field(alias="completedAtUtc")
    ] = UNSET
    r"""Time of completion for this bulk job in UTC."""

    completion_percentage: Annotated[
        OptionalNullable[float], pydantic.Field(alias="completionPercentage")
    ] = UNSET
    r"""Completion percentage for that bulk job."""

    url: OptionalNullable[str] = UNSET
    r"""The url where the result can be picked up"""

    raw_result: Annotated[OptionalNullable[str], pydantic.Field(alias="rawResult")] = (
        UNSET
    )
    r"""The raw result if the response is less than 5MB in size"""

    gql_errors: Annotated[OptionalNullable[str], pydantic.Field(alias="gqlErrors")] = (
        UNSET
    )
    r"""Any GraphQl errors"""

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = [
            "completedAtUtc",
            "completionPercentage",
            "url",
            "rawResult",
            "gqlErrors",
        ]
        nullable_fields = [
            "completedAtUtc",
            "completionPercentage",
            "url",
            "rawResult",
            "gqlErrors",
        ]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in type(self).model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m
